function [W,Q,R,A,B,C]=ctrlStp(A,B,C,M,N,O,L,t,st,nh)
// [W,Q,R,A,B,C]=ctrlStp(A,B,C,M,N,O,L,t,st,nh)
//               dynamic programming with setpoint and
//               penalization of u
// control:  u(t)=W.(Q.y(t-1)+R) 
// A,B,C     coefficients of Riccati equation
// M,N       parameters of the state model
// O,L       penalizations of output, input
// t         current time (should be pushed out)
// st        all setpoint (should be only for the current horizon)
// nh        length of horizon

for i=nh:-1:1
  s=st(:,t+i);
  V=O+A;
  W=inv(N'*V*N+L+1e-5*eye(size(L)));
  Q=N'*V*M;
  R=N'*(B'-O*s);
  
  A=M'*V*M-Q'*W*Q;
  B=(B-s'*O)*M-R'*W*Q;
  C=C+s'*O*s-R'*W*R;
end
endfunction
