function [M,N,A,nx,ny,nu]=reg2st(theta,n)
  // [M,N,A,nx,ny,nu,n]=reg2st(theta) conversion of reg.model to state-sp. one
  // M,N,A   parameters of state model    x(t)=Mx(t-1)+Nu(t),  y(t)=Ax(t)
  // nx      length of the state
  // ny,nu   number of outputs and inputs
  // theta   reg.mod. parametrs - b0 a1 b1 .. an bn k  (full str.)
  // n       model order

  [ny nt]=size(theta);
  nu=(nt-n*ny-1)/(n+1);
  nt=size(theta,2);                          // length of parameters
  nx=n*(ny+nu)+1;

  if fix(nu)~=nu, disp(' Wrong theta'), end

  // parameters of:   x(t)=Mx(t-1)+Nu(t),  y(t)=Ax(t)
  nn=(n-1)*(ny+nu);
  M=[theta(:,(nu+1):$);    
  zeros(nu,nt-nu);
  [eye(nn,nn) zeros((n-1)*(ny+nu),ny+nu+1)];
  [zeros(1,nt-nu-1) 1]];
  N=[theta(:,1:nu);eye(nu,nu);zeros(nt-ny-2*nu,nu)];
  A=[eye(ny,ny) zeros(ny,nt-ny-nu)];
endfunction
